Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -2289,17 +2369,14 @@
 
     IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_s_set_dataarray( child_id, p_3d, nz_cl, nz,                    &
-                                 array_2 = p_3d_sec )
-    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
+       CALL pmc_s_set_dataarray( child_id, p_3d, nz_child, nz, array_2 = p_3d_sec )
+    ELSEIF  ( ASSOCIATED( p_2d ) )  THEN
        CALL pmc_s_set_dataarray( child_id, p_2d )
-    ELSEIF ( ASSOCIATED( i_2d ) )  THEN
+    ELSEIF  ( ASSOCIATED( i_2d ) )  THEN
        CALL pmc_s_set_dataarray( child_id, i_2d )
     ELSE
 !
 !--    Give only one message for the root domain
-       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
-
-          message_string = 'pointer for array "' // TRIM( name ) //            &
-                           '" can''t be associated'
+       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN             
+          message_string = 'pointer for array "' // TRIM( name ) // '" can''t be associated'
           CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
        ELSE
@@ -2308,112 +2385,120 @@
           CALL MPI_BARRIER( comm2d, ierr )
        ENDIF
-
-   ENDIF
-
+       
+    ENDIF
+    
+ END SUBROUTINE pmci_set_array_pointer
+
+
+     
+ INTEGER FUNCTION get_number_of_children()
+
+    IMPLICIT NONE
+
+    
+#if defined( __parallel )
+    get_number_of_children = SIZE( pmc_parent_for_child ) - 1
+#else
+    get_number_of_children = 0
 #endif
-END SUBROUTINE pmci_set_array_pointer
-
-
-
-INTEGER FUNCTION get_number_of_childs ()     ! Change the name to "get_number_of_children"
-
-   IMPLICIT NONE
-
+
+    RETURN
+
+ END FUNCTION get_number_of_children
+
+
+ 
+ INTEGER FUNCTION get_childid( id_index )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN) ::  id_index   !<
+
+    
 #if defined( __parallel )
-   get_number_of_childs = SIZE( pmc_parent_for_child ) - 1
+    get_childid = pmc_parent_for_child(id_index)
 #else
-   get_number_of_childs = 0
+    get_childid = 0
 #endif
 
-   RETURN
-
-END FUNCTION get_number_of_childs
-
-
-INTEGER FUNCTION get_childid (id_index)
-
-   IMPLICIT NONE
-
-   INTEGER,INTENT(IN)                 :: id_index
-
-#if defined( __parallel )
-   get_childid = pmc_parent_for_child(id_index)
-#else
-   get_childid = 0
-#endif
-
-   RETURN
-
-END FUNCTION get_childid
-
-
-
-SUBROUTINE  get_child_edges (m, lx_coord, lx_coord_b, rx_coord, rx_coord_b,    &
-                               sy_coord, sy_coord_b, ny_coord, ny_coord_b,     &
-                               uz_coord, uz_coord_b)
-   IMPLICIT NONE
-   INTEGER,INTENT(IN)             ::  m
-   REAL(wp),INTENT(OUT)           ::  lx_coord, lx_coord_b
-   REAL(wp),INTENT(OUT)           ::  rx_coord, rx_coord_b
-   REAL(wp),INTENT(OUT)           ::  sy_coord, sy_coord_b
-   REAL(wp),INTENT(OUT)           ::  ny_coord, ny_coord_b
-   REAL(wp),INTENT(OUT)           ::  uz_coord, uz_coord_b
-
-   lx_coord = childgrid(m)%lx_coord
-   rx_coord = childgrid(m)%rx_coord
-   sy_coord = childgrid(m)%sy_coord
-   ny_coord = childgrid(m)%ny_coord
-   uz_coord = childgrid(m)%uz_coord
-
-   lx_coord_b = childgrid(m)%lx_coord_b
-   rx_coord_b = childgrid(m)%rx_coord_b
-   sy_coord_b = childgrid(m)%sy_coord_b
-   ny_coord_b = childgrid(m)%ny_coord_b
-   uz_coord_b = childgrid(m)%uz_coord_b
-
-END SUBROUTINE get_child_edges
-
-
-
-SUBROUTINE  get_child_gridspacing( m, dx,dy,dz )
-
-   IMPLICIT NONE
-   INTEGER,INTENT(IN)             ::  m
-   REAL(wp),INTENT(OUT)           ::  dx,dy
-   REAL(wp),INTENT(OUT),OPTIONAL  ::  dz
-
-   dx = childgrid(m)%dx
-   dy = childgrid(m)%dy
-   IF(PRESENT(dz))   THEN
-      dz = childgrid(m)%dz
-   ENDIF
-
-END SUBROUTINE get_child_gridspacing
-
-
-
-SUBROUTINE pmci_create_child_arrays( name, is, ie, js, je, nzc, n  )
-
+    RETURN
+
+ END FUNCTION get_childid
+
+
+
+ SUBROUTINE get_child_edges( m, lx_coord, lx_coord_b, rx_coord, rx_coord_b, sy_coord, sy_coord_b,   &
+      ny_coord, ny_coord_b, uz_coord, uz_coord_b )
+   
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name    !<
-
-    INTEGER(iwp), INTENT(IN) ::  ie      !<
+    INTEGER,INTENT(IN)   ::  m                     !<
+
+    REAL(wp),INTENT(OUT) ::  lx_coord, lx_coord_b  !<
+    REAL(wp),INTENT(OUT) ::  rx_coord, rx_coord_b  !<
+    REAL(wp),INTENT(OUT) ::  sy_coord, sy_coord_b  !<
+    REAL(wp),INTENT(OUT) ::  ny_coord, ny_coord_b  !<
+    REAL(wp),INTENT(OUT) ::  uz_coord, uz_coord_b  !<
+
+    
+    lx_coord = childgrid(m)%lx_coord
+    rx_coord = childgrid(m)%rx_coord
+    sy_coord = childgrid(m)%sy_coord
+    ny_coord = childgrid(m)%ny_coord
+    uz_coord = childgrid(m)%uz_coord
+    
+    lx_coord_b = childgrid(m)%lx_coord_b
+    rx_coord_b = childgrid(m)%rx_coord_b
+    sy_coord_b = childgrid(m)%sy_coord_b
+    ny_coord_b = childgrid(m)%ny_coord_b
+    uz_coord_b = childgrid(m)%uz_coord_b
+    
+ END SUBROUTINE get_child_edges
+
+
+
+ SUBROUTINE  get_child_gridspacing( m, dx, dy,dz )
+
+    IMPLICIT NONE
+   
+    INTEGER, INTENT(IN)             ::  m      !<
+
+    REAL(wp), INTENT(OUT)           ::  dx,dy  !<
+
+    REAL(wp), INTENT(OUT), OPTIONAL ::  dz     !<
+
+    
+    dx = childgrid(m)%dx
+    dy = childgrid(m)%dy
+    IF ( PRESENT( dz ) )  THEN
+       dz = childgrid(m)%dz
+    ENDIF
+    
+ END SUBROUTINE get_child_gridspacing
+
+
+
+ SUBROUTINE pmci_create_childs_parent_grid_arrays( name, is, ie, js, je, nzc, n  )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp), INTENT(IN) ::  ie      !<  RENAME ie, is, je, js?
     INTEGER(iwp), INTENT(IN) ::  is      !<
     INTEGER(iwp), INTENT(IN) ::  je      !<
     INTEGER(iwp), INTENT(IN) ::  js      !<
-    INTEGER(iwp), INTENT(IN) ::  nzc     !<  nzc is cg%nz, but note that cg%nz is not the original nz of parent, but the highest parent-grid level needed for nesting.
-
-    INTEGER(iwp), INTENT(IN), OPTIONAL ::  n  !< number of chemical species /
-                                              !< salsa variables
-
-#if defined( __parallel )
+    INTEGER(iwp), INTENT(IN) ::  nzc     !<  nzc is pg%nz, but note that pg%nz is not the original nz of parent,
+                                            !<  but the highest parent-grid level needed for nesting.
+    INTEGER(iwp), INTENT(IN), OPTIONAL ::  n  !< number of chemical species / salsa variables
+    
+    CHARACTER(LEN=*), INTENT(IN) ::  name    !<
+!       
+!-- Local variables:
     INTEGER(iwp) ::  ierr    !<
-
+    
+    INTEGER(idp), POINTER,DIMENSION(:,:)   ::  i_2d    !<
+    
     REAL(wp), POINTER,DIMENSION(:,:)       ::  p_2d    !<
     REAL(wp), POINTER,DIMENSION(:,:,:)     ::  p_3d    !<
-    INTEGER(idp), POINTER,DIMENSION(:,:)   ::  i_2d    !<
-
-
+    
     NULLIFY( p_3d )
     NULLIFY( p_2d )
@@ -2464,6 +2549,5 @@
        i_2d => part_adrc
     ELSEIF ( TRIM( name(1:5) ) == "chem_" )  THEN
-       IF ( .NOT. ALLOCATED( chem_spec_c ) )                                   &
-          ALLOCATE( chem_spec_c(0:nzc+1,js:je,is:ie,1:nspec) )
+       IF ( .NOT. ALLOCATED( chem_spec_c ) ) ALLOCATE( chem_spec_c(0:nzc+1,js:je,is:ie,1:nspec) )
        p_3d => chem_spec_c(:,:,:,n)
     ELSEIF ( TRIM( name(1:3) ) == "an_" )  THEN
@@ -2493,22 +2577,23 @@
     ELSE
 !
-!--    Give only one message for the first child domain
+!-- Give only one message for the first child domain.
        IF ( myid == 0  .AND.  cpl_id == 2 )  THEN
-
           message_string = 'pointer for array "' // TRIM( name ) //            &
-                           '" can''t be associated'
-          CALL message( 'pmci_create_child_arrays', 'PA0170', 3, 2, 0, 6, 0 )
+               '" can''t be associated'
+          CALL message( 'pmci_create_childs_parent_grid_arrays', 'PA0170', 3, 2, 0, 6, 0 )
        ELSE
 !
-!--       Prevent others from continuing
+!--          Prevent others from continuing in case the abort is to come.
           CALL MPI_BARRIER( comm2d, ierr )
        ENDIF
+
     ENDIF
 
-#endif
- END SUBROUTINE pmci_create_child_arrays
-
-
-
+ END SUBROUTINE pmci_create_childs_parent_grid_arrays
+
+
+!
+! E N D   O F    S E T U P   R O U T I N E S 
+!
  SUBROUTINE pmci_parent_initialize
 
@@ -2542,44 +2627,16 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i          !<
-    INTEGER(iwp) ::  ib         !< running index for aerosol size bins
-    INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
-    INTEGER(iwp) ::  icl        !<
-    INTEGER(iwp) ::  icla       !<
-    INTEGER(iwp) ::  iclw       !<
-    INTEGER(iwp) ::  icr        !<
-    INTEGER(iwp) ::  icra       !<
-    INTEGER(iwp) ::  icrw       !<
-    INTEGER(iwp) ::  ig         !< running index for salsa gases
-    INTEGER(iwp) ::  j          !<
-    INTEGER(iwp) ::  jcn        !<
-    INTEGER(iwp) ::  jcna       !<
-    INTEGER(iwp) ::  jcnw       !<
-    INTEGER(iwp) ::  jcs        !<
-    INTEGER(iwp) ::  jcsa       !<
-    INTEGER(iwp) ::  jcsw       !<
-    INTEGER(iwp) ::  k          !< 
-    INTEGER(iwp) ::  n          !< running index for chemical species
-
-    REAL(wp) ::  waittime       !<
+    INTEGER(iwp) ::  ic         !< Child-grid index in x-direction
+    INTEGER(iwp) ::  jc         !< Child-grid index in y-direction
+    INTEGER(iwp) ::  kc         !< Child-grid index in z-direction
+    INTEGER(iwp) ::  lb         !< Running index for aerosol size bins
+    INTEGER(iwp) ::  lc         !< Running index for aerosol mass bins 
+    INTEGER(iwp) ::  lg         !< Running index for salsa gases
+    INTEGER(iwp) ::  n          !< Running index for chemical species
+    REAL(wp) ::  waittime       !< Waiting time 
 
 !
 !-- Root model is never anyone's child
     IF ( cpl_id > 1 )  THEN
-!
-!--    Child domain boundaries in the parent index space
-       icl  = coarse_bound(1)
-       icr  = coarse_bound(2)
-       jcs  = coarse_bound(3)
-       jcn  = coarse_bound(4)
-       icla = coarse_bound_aux(1)
-       icra = coarse_bound_aux(2)
-       jcsa = coarse_bound_aux(3)
-       jcna = coarse_bound_aux(4)
-       iclw = coarse_bound_w(1)
-       icrw = coarse_bound_w(2)
-       jcsw = coarse_bound_w(3)
-       jcnw = coarse_bound_w(4)
-
 !
 !--    Get data from the parent
@@ -2633,15 +2690,15 @@
 
        IF ( salsa  .AND.  nest_salsa )  THEN
-          DO  ib = 1, nbins_aerosol
-             CALL pmci_interp_1sto_all ( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),        &
+          DO  lb = 1, nbins_aerosol
+             CALL pmci_interp_1sto_all ( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),       &
                                          kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
           ENDDO
-          DO  ic = 1, nbins_aerosol * ncomponents_mass
-             CALL pmci_interp_1sto_all ( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),            &
+          DO  lc = 1, nbins_aerosol * ncomponents_mass
+             CALL pmci_interp_1sto_all ( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),           &
                                          kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
           ENDDO
           IF ( .NOT. salsa_gases_from_chem )  THEN
-             DO  ig = 1, ngases_salsa
-                CALL pmci_interp_1sto_all ( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),             &
+             DO  lg = 1, ngases_salsa
+                CALL pmci_interp_1sto_all ( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),              &
                                             kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
              ENDDO
@@ -2651,26 +2708,14 @@
        IF ( topography /= 'flat' )  THEN
 !
-!--       Inside buildings set velocities and TKE back to zero.
-!--       Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at present,
-!--       maybe revise later.
-          DO   i = nxlg, nxrg
-             DO   j = nysg, nyng
-                DO  k = nzb, nzt
-                   u(k,j,i)   = MERGE( u(k,j,i), 0.0_wp,                       &
-                                       BTEST( wall_flags_0(k,j,i), 1 ) )
-                   v(k,j,i)   = MERGE( v(k,j,i), 0.0_wp,                       &
-                                       BTEST( wall_flags_0(k,j,i), 2 ) )
-                   w(k,j,i)   = MERGE( w(k,j,i), 0.0_wp,                       &
-                                       BTEST( wall_flags_0(k,j,i), 3 ) )
-!                    e(k,j,i)   = MERGE( e(k,j,i), 0.0_wp,                       &
-!                                        BTEST( wall_flags_0(k,j,i), 0 ) )
-                   u_p(k,j,i) = MERGE( u_p(k,j,i), 0.0_wp,                     &
-                                       BTEST( wall_flags_0(k,j,i), 1 ) )
-                   v_p(k,j,i) = MERGE( v_p(k,j,i), 0.0_wp,                     &
-                                       BTEST( wall_flags_0(k,j,i), 2 ) )
-                   w_p(k,j,i) = MERGE( w_p(k,j,i), 0.0_wp,                     &
-                                       BTEST( wall_flags_0(k,j,i), 3 ) )
-!                    e_p(k,j,i) = MERGE( e_p(k,j,i), 0.0_wp,                     &
-!                                        BTEST( wall_flags_0(k,j,i), 0 ) )
+!--       Inside buildings set velocities back to zero.
+          DO  ic = nxlg, nxrg
+             DO  jc = nysg, nyng
+                DO  kc = nzb, nzt
+                   u(kc,jc,ic)   = MERGE( u(kc,jc,ic), 0.0_wp, BTEST( wall_flags_0(kc,jc,ic), 1 ) )
+                   v(kc,jc,ic)   = MERGE( v(kc,jc,ic), 0.0_wp, BTEST( wall_flags_0(kc,jc,ic), 2 ) )
+                   w(kc,jc,ic)   = MERGE( w(kc,jc,ic), 0.0_wp, BTEST( wall_flags_0(kc,jc,ic), 3 ) )
+                   u_p(kc,jc,ic) = MERGE( u_p(kc,jc,ic), 0.0_wp, BTEST( wall_flags_0(kc,jc,ic), 1 ) )
+                   v_p(kc,jc,ic) = MERGE( v_p(kc,jc,ic), 0.0_wp, BTEST( wall_flags_0(kc,jc,ic), 2 ) )
+                   w_p(kc,jc,ic) = MERGE( w_p(kc,jc,ic), 0.0_wp, BTEST( wall_flags_0(kc,jc,ic), 3 ) )
                 ENDDO
              ENDDO
@@ -2683,97 +2728,106 @@
 
 
-    SUBROUTINE pmci_interp_1sto_all( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu, var )
+    SUBROUTINE pmci_interp_1sto_all( child_array, parent_array, kct, ifl, ifu, jfl, jfu, kfl, kfu,  &
+         var )
 !
 !--    Interpolation of the internal values for the child-domain initialization
        IMPLICIT NONE
 
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f  !< Child-grid array 
-       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc        !< Parent-grid array
-       INTEGER(iwp) :: kct                                    !< The parent-grid index in z-direction just below the boundary value node
-       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates end index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu !< Indicates end index of child cells belonging to certain parent cell - z direction
-       CHARACTER(LEN=1), INTENT(IN) :: var                    !< Variable symbol: 'u', 'v', 'w' or 's'
+       INTEGER(iwp), INTENT(IN) ::  kct  !< The parent-grid index in z-direction just below the boundary value node
+
+       INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifl  !<  Indicates start index of child cells belonging to certain
+                                                               !<  parent cell - x direction
+       INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifu  !<  Indicates end index of child cells belonging to certain
+                                                               !<  parent cell - x direction
+       INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfl  !<  Indicates start index of child cells belonging to certain
+                                                               !<  parent cell - y direction
+       INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfu  !<  Indicates end index of child cells belonging to certain
+                                                               !<  parent cell - y direction
+       INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfl  !<  Indicates start index of child cells belonging to certain
+                                                               !<  parent cell - z direction
+       INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfu  !<  Indicates end index of child cells belonging to certain
+                                                               !<  parent cell - z direction
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  child_array  !<  Child-grid array 
+       REAL(wp), DIMENSION(0:pg%nz+1,jps:jpn,ipl:ipr), INTENT(IN) ::  parent_array        !<  Parent-grid array
+
+       CHARACTER(LEN=1), INTENT(IN) ::  var  !<  Variable symbol: 'u', 'v', 'w' or 's'
 !
 !--    Local variables:
-       INTEGER(iwp) ::  i        !<
-       INTEGER(iwp) ::  ib       !<
-       INTEGER(iwp) ::  ie       !<
-       INTEGER(iwp) ::  ifirst   !<
-       INTEGER(iwp) ::  ilast    !<
-       INTEGER(iwp) ::  j        !<
-       INTEGER(iwp) ::  jb       !<
-       INTEGER(iwp) ::  je       !<
-       INTEGER(iwp) ::  jfirst   !<
-       INTEGER(iwp) ::  jlast    !<
-       INTEGER(iwp) ::  k        !<
-       INTEGER(iwp) ::  l        !<
-       INTEGER(iwp) ::  lb       !<
-       INTEGER(iwp) ::  le       !<
-       INTEGER(iwp) ::  m        !<
-       INTEGER(iwp) ::  mb       !<
-       INTEGER(iwp) ::  me       !<
-       INTEGER(iwp) ::  n        !<
-
-
-       lb = icl
-       le = icr
-       mb = jcs
-       me = jcn
-       ifirst = nxl
-       ilast  = nxr
-       jfirst = nys
-       jlast  = nyn
+       INTEGER(iwp) ::  ic        !< Running child-grid index in the x-direction
+       INTEGER(iwp) ::  icfirst   !< Leftmost child-grid index initialized by the main loops (usually icfirst == icl_init)
+       INTEGER(iwp) ::  iclast    !< Rightmost child-grid index initialized by the main loops (usually iclast == icr_init)
+       INTEGER(iwp) ::  icl_init  !< Left child-grid index bound for initialization in the x-direction
+       INTEGER(iwp) ::  icr_init  !< Right child-grid index bound for initialization in the x-direction
+       INTEGER(iwp) ::  jc        !< Running child-grid index in the y-direction
+       INTEGER(iwp) ::  jcfirst   !< Southmost child-grid index initialized by the main loops (usually jcfirst == jcs_init)
+       INTEGER(iwp) ::  jclast    !< Northmost child-grid index initialized by the main loops (usually jclast == jcn_init)
+       INTEGER(iwp) ::  jcs_init  !< South child-grid index bound for initialization in the y-direction
+       INTEGER(iwp) ::  jcn_init  !< North child-grid index bound for initialization in the y-direction
+       INTEGER(iwp) ::  kc        !< Running child-grid index in the z-direction
+       INTEGER(iwp) ::  ip        !< Running parent-grid index in the x-direction
+       INTEGER(iwp) ::  ipl_init  !< Left parent-grid index bound for initialization in the x-direction
+       INTEGER(iwp) ::  ipr_init  !< Right parent-grid index bound for initialization in the x-direction
+       INTEGER(iwp) ::  jp        !< Running parent-grid index in the y-direction
+       INTEGER(iwp) ::  jps_init  !< South parent-grid index bound for initialization in the y-direction
+       INTEGER(iwp) ::  jpn_init  !< North parent-grid index bound for initialization in the y-direction
+       INTEGER(iwp) ::  kp        !< Running parent-grid index in the z-direction
+
+
+       ipl_init = ipl
+       ipr_init = ipr
+       jps_init = jps
+       jpn_init = jpn
+       icl_init = nxl
+       icr_init = nxr
+       jcs_init = nys
+       jcn_init = nyn
 
        IF ( nesting_mode /= 'vertical' )  THEN
           IF ( bc_dirichlet_l )  THEN
-             lb     = icl + 1
-             ifirst = nxl - 1
+             ipl_init = ipl + 1
+             icl_init = nxl - 1
 !
 !--          For u, nxl is a ghost node, but not for the other variables
              IF ( var == 'u' )  THEN
-                lb     = icl + 2
-                ifirst = nxl
+                ipl_init = ipl + 2
+                icl_init = nxl
              ENDIF
           ENDIF
           IF ( bc_dirichlet_s )  THEN
-             mb     = jcs + 1
-             jfirst = nys - 1 
+             jps_init = jps + 1
+             jcs_init = nys - 1 
 !
 !--          For v, nys is a ghost node, but not for the other variables
              IF ( var == 'v' )  THEN
-                mb     = jcs + 2
-                jfirst = nys
+                jps_init = jps + 2
+                jcs_init = nys
              ENDIF
           ENDIF
           IF ( bc_dirichlet_r )  THEN
-             le    = icr - 1
-             ilast = nxr + 1 
+             ipr_init = ipr - 1
+             icr_init = nxr + 1 
           ENDIF
           IF ( bc_dirichlet_n )  THEN
-             me    = jcn - 1
-             jlast = nyn + 1
+             jpn_init = jpn - 1
+             jcn_init = nyn + 1
           ENDIF
        ENDIF      
 
-       f(:,:,:) = 0.0_wp
-
-       IF  ( var == 'u' )  THEN
-
-          ib = ifl(lb) 
-          ie = ifl(le+1) - 1
-          jb = jfl(mb)
-          je = jfu(me)
-          DO  l = lb, le
-             DO  m = mb, me
-                DO n = 0, kct + 1 
-
-                   DO  i = ifl(l), ifl(l+1)-1
-                      DO  j = jfl(m), jfu(m)
-                         DO  k = kfl(n), MIN( kfu(n), nzt+1 )
-                            f(k,j,i) = fc(n,m,l)
+       child_array(:,:,:) = 0.0_wp
+
+       IF ( var == 'u' )  THEN
+
+          icfirst = ifl(ipl_init) 
+          iclast  = ifl(ipr_init+1) - 1
+          jcfirst = jfl(jps_init)
+          jclast  = jfu(jpn_init)
+          DO  ip = ipl_init, ipr_init
+             DO  jp = jps_init, jpn_init
+                DO  kp = 0, kct + 1 
+
+                   DO  ic = ifl(ip), ifl(ip+1)-1
+                      DO  jc = jfl(jp), jfu(jp)
+                         DO  kc = kfl(kp), MIN( kfu(kp), nzt+1 )
+                            child_array(kc,jc,ic) = parent_array(kp,jp,ip)
                          ENDDO
                       ENDDO
@@ -2784,18 +2838,18 @@
           ENDDO
 
-       ELSE IF  ( var == 'v' )  THEN
-
-          ib = ifl(lb) 
-          ie = ifu(le)
-          jb = jfl(mb)
-          je = jfl(me+1) - 1
-          DO  l = lb, le
-             DO  m = mb, me
-                DO n = 0, kct + 1  
-
-                   DO i = ifl(l), ifu(l)
-                      DO  j = jfl(m), jfl(m+1)-1
-                         DO  k = kfl(n), MIN( kfu(n), nzt+1 )
-                            f(k,j,i) = fc(n,m,l) 
+       ELSE IF ( var == 'v' )  THEN
+
+          icfirst = ifl(ipl_init) 
+          iclast  = ifu(ipr_init)
+          jcfirst = jfl(jps_init)
+          jclast  = jfl(jpn_init+1) - 1
+          DO  ip = ipl_init, ipr_init
+             DO  jp = jps_init, jpn_init
+                DO  kp = 0, kct + 1  
+
+                   DO  ic = ifl(ip), ifu(ip)
+                      DO  jc = jfl(jp), jfl(jp+1)-1
+                         DO  kc = kfl(kp), MIN( kfu(kp), nzt+1 )
+                            child_array(kc,jc,ic) = parent_array(kp,jp,ip) 
                          ENDDO
                       ENDDO
@@ -2806,19 +2860,21 @@
           ENDDO
 
-       ELSE IF  ( var == 'w' )  THEN
-
-          ib = ifl(lb) 
-          ie = ifu(le)
-          jb = jfl(mb)
-          je = jfu(me)
-          DO  l = lb, le
-             DO  m = mb, me
-                DO n = 1, kct + 1  
-
-                   DO i = ifl(l), ifu(l)
-                      DO  j = jfl(m), jfu(m)
-                         f(nzb,j,i) = 0.0_wp   ! Because the n-loop starts from n=1 instead of 0
-                         DO  k = kfu(n-1)+1, kfu(n) 
-                            f(k,j,i) = fc(n,m,l)
+       ELSE IF ( var == 'w' )  THEN
+
+          icfirst = ifl(ipl_init) 
+          iclast  = ifu(ipr_init)
+          jcfirst = jfl(jps_init)
+          jclast  = jfu(jpn_init)
+          DO  ip = ipl_init, ipr_init
+             DO  jp = jps_init, jpn_init
+                DO  kp = 1, kct + 1  
+
+                   DO  ic = ifl(ip), ifu(ip)
+                      DO  jc = jfl(jp), jfu(jp)
+!                         
+!--                      Because the kp-loop for w starts from kp=1 instead of 0
+                         child_array(nzb,jc,ic) = 0.0_wp
+                         DO  kc = kfu(kp-1)+1, kfu(kp) 
+                            child_array(kc,jc,ic) = parent_array(kp,jp,ip)
                          ENDDO
                       ENDDO
@@ -2831,16 +2887,16 @@
        ELSE   ! scalars
 
-          ib = ifl(lb) 
-          ie = ifu(le)
-          jb = jfl(mb)
-          je = jfu(me)
-          DO  l = lb, le
-             DO  m = mb, me
-                DO n = 0, kct + 1
+          icfirst = ifl(ipl_init) 
+          iclast  = ifu(ipr_init)
+          jcfirst = jfl(jps_init)
+          jclast  = jfu(jpn_init)
+          DO  ip = ipl_init, ipr_init
+             DO  jp = jps_init, jpn_init
+                DO  kp = 0, kct + 1
                                       
-                   DO i = ifl(l), ifu(l)
-                      DO  j = jfl(m), jfu(m)                         
-                         DO  k = kfl(n), MIN( kfu(n), nzt+1 )
-                            f(k,j,i) = fc(n,m,l)
+                   DO  ic = ifl(ip), ifu(ip)
+                      DO  jc = jfl(jp), jfu(jp)                         
+                         DO  kc = kfl(kp), MIN( kfu(kp), nzt+1 )
+                            child_array(kc,jc,ic) = parent_array(kp,jp,ip)
                          ENDDO
                       ENDDO
@@ -2853,26 +2909,26 @@
        ENDIF  ! var
 !
-!--    If the subdomain i- and/or j-dimension (nx/npex and/or ny/npey) is 
-!--    not integer divisible by the grid spacing ratio in its direction,
-!--    the above loops will return with unfilled gaps in the initial fields.
-!--    These gaps, if present, are filled here.  
-       IF  ( ib > ifirst )  THEN
-          DO  i = ifirst, ib-1
-             f(:,:,i) = f(:,:,ib)
+!--    If the number of grid points in child subdomain in x- or y-direction
+!--    (nxr - nxl + 1 and/or nyn - nys + 1) is not integer divisible by the grid spacing
+!--    ratio in its direction (igsr and/or jgsr), the above loops will return with 
+!--    unfilled gaps in the initial fields. These gaps, if present, are filled here.  
+       IF ( icfirst > icl_init )  THEN
+          DO  ic = icl_init, icfirst - 1
+             child_array(:,:,ic) = child_array(:,:,icfirst)
           ENDDO
        ENDIF
-       IF  ( ie < ilast )  THEN
-          DO  i = ie+1, ilast
-             f(:,:,i) = f(:,:,ie)
+       IF ( iclast < icr_init )  THEN
+          DO  ic = iclast + 1, icr_init
+             child_array(:,:,ic) = child_array(:,:,iclast)
           ENDDO
        ENDIF
-       IF  ( jb > jfirst )  THEN
-          DO  j = jfirst, jb-1
-             f(:,j,:) = f(:,jb,:)
+       IF ( jcfirst > jcs_init )  THEN
+          DO  jc = jcs_init, jcfirst - 1
+             child_array(:,jc,:) = child_array(:,jcfirst,:)
           ENDDO
        ENDIF
-       IF  ( je < jlast )  THEN
-          DO  j = je+1, jlast
-             f(:,j,:) = f(:,je,:)
+       IF ( jclast < jcn_init )  THEN
+          DO  jc = jclast + 1, jcn_init
+             child_array(:,jc,:) = child_array(:,jclast,:)
           ENDDO
        ENDIF
@@ -2887,5 +2943,5 @@
  SUBROUTINE pmci_check_setting_mismatches
 !
-!-- Check for mismatches between settings of master and child variables
+!-- Check for mismatches between settings of root and child variables
 !-- (e.g., all children have to follow the end_time settings of the root model).
 !-- The root model overwrites variables in the other models, so these variables
@@ -2894,15 +2950,15 @@
 #if defined( __parallel )
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                         &
         ONLY:  dt_restart, end_time, message_string, restart_time, time_restart
 
     IMPLICIT NONE
 
-    INTEGER ::  ierr
-
-    REAL(wp) ::  dt_restart_root
-    REAL(wp) ::  end_time_root
-    REAL(wp) ::  restart_time_root
-    REAL(wp) ::  time_restart_root
+    INTEGER ::  ierr                 !<  MPI error code
+
+    REAL(wp) ::  dt_restart_root     !< 
+    REAL(wp) ::  end_time_root       !<  
+    REAL(wp) ::  restart_time_root   !< 
+    REAL(wp) ::  time_restart_root   !<  
 
 !
@@ -2916,9 +2972,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( end_time /= end_time_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',      &
-               'child settings:& end_time(root) = ', end_time_root,            &
-               '& end_time(child) = ', end_time, '& child value is set',       &
+          WRITE( message_string, * )  'mismatch between root model and ',                           &
+               'child settings:& end_time(root) = ', end_time_root,                                 &
+               '& end_time(child) = ', end_time, '& child value is set',                            &
                ' to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,                      &
                         0 )
           end_time = end_time_root
@@ -2990,12 +3046,12 @@
    IMPLICIT NONE
 
-   INTEGER(iwp)           :: ierr  !<
-   REAL(wp), DIMENSION(1) :: dtl   !<
-   REAL(wp), DIMENSION(1) :: dtg   !<
+   INTEGER(iwp) ::  ierr  !<  MPI error code
+   REAL(wp) ::  dtl       !<  Local time step of the current process
+   REAL(wp) ::  dtg       !<  Global time step defined as the global minimum of dtl of all processes
 
    
-   dtl(1) = dt_3d 
+   dtl = dt_3d
    CALL MPI_ALLREDUCE( dtl, dtg, 1, MPI_REAL, MPI_MIN, MPI_COMM_WORLD, ierr )
-   dt_3d  = dtg(1)
+   dt_3d  = dtg
 
 #endif
@@ -3012,12 +3068,11 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(IN) ::  swaplevel  !< swaplevel (1 or 2) of PALM's
-                                            !< timestep
-
-    INTEGER(iwp)            ::  child_id    !<
-    INTEGER(iwp)            ::  m           !<
+    INTEGER(iwp), INTENT(IN) ::  swaplevel  !< swaplevel (1 or 2) of PALM's timestep
+
+    INTEGER(iwp) ::  child_id    !<  Child id of the child number m
+    INTEGER(iwp) ::  m           !<  Loop index over all children of the current parent 
 
 #if defined( __parallel )
-    DO  m = 1, SIZE( pmc_parent_for_child )-1
+    DO  m = 1, SIZE( pmc_parent_for_child ) - 1
        child_id = pmc_parent_for_child(m)
        CALL pmc_s_set_active_data_array( child_id, swaplevel )
@@ -3042,5 +3097,5 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  local_nesting_mode
+    CHARACTER(LEN=*), INTENT(IN) ::  local_nesting_mode  !<  Nesting mode: 'one-way', 'two-way' or 'vertical'
 
 
@@ -3052,5 +3107,5 @@
     ELSE
 
-       IF( nesting_datatransfer_mode == 'cascade' )  THEN
+       IF ( nesting_datatransfer_mode == 'cascade' )  THEN
 
           CALL pmci_child_datatrans( parent_to_child )
